use http://www.stata-press.com/data/r13/air2.dta
generate logair100 = ln(air)*100

* Contstraints definition
* -- local linear trend
constraint define 1 [level]L.level=1
constraint define 2 [level]L.slope=1
* -- stochastic seasonal dummies
constraint define 3 [gamma]L.gamma=-1
constraint define 4 [gamma]L.gamma1=-1
constraint define 5 [gamma]L.gamma2=-1
constraint define 6 [gamma]L.gamma3=-1
constraint define 7 [gamma]L.gamma4=-1
constraint define 8 [gamma]L.gamma5=-1
constraint define 9 [gamma]L.gamma6=-1
constraint define 10 [gamma]L.gamma7=-1
constraint define 11 [gamma]L.gamma8=-1
constraint define 12 [gamma]L.gamma9=-1
constraint define 13 [gamma]L.gamma10=-1
constraint define 14 [gamma1]L.gamma=1
constraint define 15 [gamma2]L.gamma1=1
constraint define 16 [gamma3]L.gamma2=1
constraint define 17 [gamma4]L.gamma3=1
constraint define 18 [gamma5]L.gamma4=1
constraint define 19 [gamma6]L.gamma5=1
constraint define 20 [gamma7]L.gamma6=1
constraint define 21 [gamma8]L.gamma7=1
constraint define 22 [gamma9]L.gamma8=1
constraint define 23 [gamma10]L.gamma9=1
constraint define 24 [logair100]level=1
constraint define 25 [logair100]gamma=1

* State space form definition
sspace	(level L.level L.slope, state noconstant) /// level
		(slope L.slope, state noerror noconstant) /// slope (fixed, otherwise it does not converge)
		(gamma L.gamma L.gamma1 L.gamma2 L.gamma3 L.gamma4 L.gamma5 L.gamma6 L.gamma7 L.gamma8 L.gamma9 L.gamma10, state noconstant) /// seasonal stoch. dummy var
		(gamma1 L.gamma, state noerror noconstant) ///   identity: gamma1 = lag(gamma)
		(gamma2 L.gamma1, state noerror noconstant) ///  identity: gamma2 = lag(gamma1)
		(gamma3 L.gamma2, state noerror noconstant) ///  identity: gamma3 = lag(gamma2)
		(gamma4 L.gamma3, state noerror noconstant) ///  identity: gamma4 = lag(gamma3)
		(gamma5 L.gamma4, state noerror noconstant) ///  identity: gamma5 = lag(gamma4)
		(gamma6 L.gamma5, state noerror noconstant) ///  identity: gamma6 = lag(gamma5)
		(gamma7 L.gamma6, state noerror noconstant) ///  identity: gamma7 = lag(gamma6)
		(gamma8 L.gamma7, state noerror noconstant) ///  identity: gamma8 = lag(gamma7)
		(gamma9 L.gamma8, state noerror noconstant) ///  identity: gamma9 = lag(gamma8)
		(gamma10 L.gamma9, state noerror noconstant) /// identity: gamma10 = lag(gamma9)
		(logair100 level gamma, noconstant), constraints(1/25) difficult /// obs. equation and options

* Run smoother
predict smo*, states smethod(smooth)

* Plot trend and series
twoway (tsline logair100) (tsline smo1)
