* load data from web
use http://www.stata-press.com/data/r13/air2.dta
* compute 100 time the log of passengers (in 1000)
generate logair100 = ln(air)*100
* estimate model: random walk (LLT does not converge) + stoch. dummy seasonal + noise
ucm lair100, model(lldtrend) seasonal(12)
* create smoothed level component
predict smoothed_level, trend smethod(smooth)
* create smoothed seasonal component
predict smoothed_seas, seasonal smethod(smooth)
* plot series + level
twoway (tsline lair100) (tsline smoothed_level, lcolor(blue) lwidth(medium))
* plot seasonal component
twoway (tsline smoothed_seas)
